#!/usr/bin/perl -w
#######################################################
# Simple Web Browsing Bot.  Written By Joe McCormack. #
# Last Modified: 8/5/09.			      #
#######################################################

##### Declare Container For Response Stream
local our $captured_response;

##### Variable Arguments Passed Into Bot Engine
local our $port, $agent_name, $agent_method, $target_domain, $target_full_address, $request_method, $request_protocol;
##### Other
local our $captured_response, $captured_response_filtered, $record, $collectchars, $absPath, $absPathTick, $absPathQuote;
local our $allowimages, $allowlinks, $ldState;

##### Default Settings
$port = 80;
$agent_name = "browserbot";
$agent_method = "http-get/0.1";
$target_domain = "";
$target_full_address = "";
$request_method = "GET";
$request_protocol = "HTTP/1.0";
$allowimages = 0;
$allowlinks = 1;
$ldState = "";

##### The Raw Bot Engine
sub botEngine() {
# Define Some Local (Private) Variables
my $remote, $data_result, $error, $volume, $datastream, $len;

# Parse Arguments Array (variables being passed into this subroutine)
my ($port, $agent_name, $agent_method, $target_domain, $target_full_address, $request_method, $request_protocol) = @_;

# Define Socket Connection
sub TCP { join("", getprotobyname('tcp')); }
sub SOCK_STREAM { 1; }
sub AF_INET { 2; }
sub PF_INET { &AF_INET; }

# Build Identification Header
@Headers = ("User-Agent:$agent_name", $agent_method);

# Resolve Domain To IP Address Using IPv4
if ($target_domain =~ /^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$/) { @addrs = pack('C4', split(/\./,$target_domain)); } 
else { ($dummy,$dummy,$dummy,$dummy, @addrs) = gethostbyname($target_domain); }
$remote = pack("S n a4 x8", &AF_INET, $port, $addrs[0]);

# Open Socket Connection
unless (socket(S, &PF_INET, &SOCK_STREAM, &TCP)) { $error = 1; $data_result = "Socket Connection Error 1"; }

# Send Request.  Gather Response Stream.
if ($error == 0) {
                  unless (connect(S, $remote)) {
						$error = 1;
						$data_result = "Socket Connection Error 1 - Attempt 2";
					       }
                  if ($error == 0) {
                                    select(S); $| = 1; select(STDOUT); $| = 1;
                                    $request = "$request_method $target_full_address $request_protocol\r\n";
                                    while ($#Headers > 0) { $request = $request . "$Headers[0]: $Headers[1]\r\n"; shift(@Headers); shift(@Headers); }
                                    $request = $request . "\r\n"; print(S $request);
                                    $volume = 1024*1024;
                                    while ($len = sysread(S, $datastream, $volume)) { $captured_response .= $datastream; }  
                                   }
               }

# Close Socket Connection.
unless (close(S)) { $data_result = "Socket Close Error 1"; }
else { $data_result = "Connection Successful"; }

# Return Status Event Response.
return $data_result;
}

##### Grab POST Data
read(STDIN, $myaction, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $myaction); 
foreach $pair (@pairs) {
		        ($name, $value) = split(/=/, $pair);
		        $value =~ tr/+/ /;
		        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		        $value =~ s/<([^>]|\n)*>//g;
		        $value =~ s/^\n//g;
		        $value =~ s/\r//g;
		        $FORM{$name} = $value;
                       }

##### Assign POST Data
if (length($FORM{'target_domain'}) > 0) { $target_domain = $FORM{'target_domain'}; }
if (length($FORM{'target_full_address'}) > 0) { $target_full_address = $FORM{'target_full_address'}; }
if (length($FORM{'port'}) > 0) { $port = $FORM{'port'}; }
if (length($FORM{'agent_name'}) > 0) { $agent_name = $FORM{'agent_name'}; }
if (length($FORM{'agent_method'}) > 0) { $agent_method = $FORM{'agent_method'}; }
if (length($FORM{'request_method'}) > 0) { $request_method = $FORM{'request_method'}; }
if (length($FORM{'request_protocol'}) > 0) { $request_protocol = $FORM{'request_protocol'}; }
if (length($FORM{'ldState'}) > 0) { $ldState = $FORM{'ldState'}; }
if (length($FORM{'allowimages'}) > 0) { $allowimages = $FORM{'allowimages'}; }
if (length($FORM{'allowlinks'}) > 0) { $allowlinks = $FORM{'allowlinks'}; }

##### Invoke Web Bot
if (length($target_domain) > 0 && length($target_full_address)) {
								 $response = &botEngine($port, $agent_name, $agent_method, $target_domain, $target_full_address, $request_method, $request_protocol);
								}

##### Filter Content
$captured_response_filtered = $captured_response;
$captured_response_filtered =~ s/\n//g; $captured_response_filtered =~ s/\r//g; $captured_response_filtered =~ s/\r\n//g; 
if ($captured_response_filtered =~ /<body(.*)<\/body/i) { $captured_response_filtered = $1; }
else {
      @segment = split(/<body/i, $captured_response_filtered); $captured_response_filtered = $segment[1];
      @segment2 = split(/<script/i, $captured_response_filtered); $captured_response_filtered = $segment2[0];
      $captured_response_filtered = $captured_response_filtered . "</div>";
     }
##### Drop remainder of opening body tag
$record = 0;
$collectchars = "";
for ($x = 0; $x < length($captured_response_filtered); $x++) {
							      if ($record == 1) { $collectchars = $collectchars . substr($captured_response_filtered, $x, 1); }
							      if (substr($captured_response_filtered, $x, 1) eq ">") { $record = 1; }
							     }
##### Replace non-absolute paths
if ($port == 80) {
		  $absPath = "http://$target_domain/";
		  $absPathTick = "'http://$target_domain/";
		  $absPathQuote = "\"http://$target_domain/";
		 }
else {
      $absPath = "https://$target_domain/";
      $absPathTick = "'https://$target_domain/";
      $absPathQuote = "\"https://$target_domain/";
     }

##### Replace src
if ($allowimages == 1) {
		  	$collectchars =~ s/src=\//src=$absPath/g;
		  	$collectchars =~ s/SRC=\//SRC=$absPath/g;
		  	$collectchars =~ s/src='\//src=$absPathTick/g;
		  	$collectchars =~ s/SRC='\//SRC=$absPathTick/g;
		  	$collectchars =~ s/src=\"\//src=$absPathQuote/g;
		  	$collectchars =~ s/SRC=\"\//SRC=$absPathQuote/g;
		       }
else {
      $collectchars =~ s/src=\///g;
      $collectchars =~ s/SRC=\///g;
      $collectchars =~ s/src='\//'/g;
      $collectchars =~ s/SRC='\//'/g;
      $collectchars =~ s/src=\"\//\"/g;
      $collectchars =~ s/SRC=\"\//\"/g;
     }

##### Replace action
if ($allowimages == 1) {
			$collectchars =~ s/action=\//action=$absPath/g;
		  	$collectchars =~ s/ACTION=\//ACTION=$absPath/g;
		  	$collectchars =~ s/action='\//action=$absPathTick/g;
		  	$collectchars =~ s/ACTION='\//ACTION=$absPathTick/g;
		  	$collectchars =~ s/action=\"\//action=$absPathQuote/g;
		  	$collectchars =~ s/ACTION=\"\//ACTION=$absPathQuote/g;
		       }
else {
      $collectchars =~ s/action=\///g;
      $collectchars =~ s/ACTION=\///g;
      $collectchars =~ s/action='\//'/g;
      $collectchars =~ s/ACTION='\//'/g;
      $collectchars =~ s/action=\"\//\"/g;
      $collectchars =~ s/ACTION=\"\//\"/g;
     }

##### Replace inline CSS url
if ($allowimages == 1) {
			$collectchars =~ s/url\(\/(.*?)\)/url($absPath$1)/g;
		  	$collectchars =~ s/URL\(\/(.*?)\)/URL($absPath$1)/g;
		  	$collectchars =~ s/url\('\/(.*?)'\)/url($absPathTick$1')/g;
		  	$collectchars =~ s/URL\('\/(.*?)'\)/URL($absPathTick$1')/g;
		  	$collectchars =~ s/url\(\"\/(.*?)\)/url($absPathQuote$1\")/g;
		  	$collectchars =~ s/URL\(\"\/(.*?)\)/URL($absPathQuote$1\")/g;
		       }
else {
      $collectchars =~ s/url\((.*?)\)//g;
      $collectchars =~ s/URL\((.*?)\)//g;
     }

##### Arrays with absolute paths
if ($allowimages == 0) {
			$collectchars =~ s/\((.*)'http:\/\/(.*?)'(.*)\)/$1''$3/g;
			$collectchars =~ s/\((.*)'HTTP:\/\/(.*?)'(.*)\)/$1''$3/g;
			$collectchars =~ s/\((.*)'https:\/\/(.*?)'(.*)\)/$1''$3/g;
			$collectchars =~ s/\((.*)'HTTPS:\/\/(.*?)'(.*)\)/$1''$3/g;
		       }

##### Replace href
if ($allowlinks == 1) {
		       $collectchars =~ s/href='\/'/href=\"#\" onclick=\"linkGrab('\/');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/');\" onmouseout=\"linkMsgStatus('out','');\"/g;
		       $collectchars =~ s/href='\/(.*?)'/href=\"#\" onclick=\"linkGrab('\/$1');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/$1');\" onmouseout=\"linkMsgStatus('out','');\"/g;
		       $collectchars =~ s/HREF='\/(.*?)'/href=\"#\" onclick=\"linkGrab('\/$1');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/$1');\" onmouseout=\"linkMsgStatus('out','');\"/g;
		       $collectchars =~ s/href=\"\/\"/href=\"#\" onclick=\"linkGrab('\/');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/');\" onmouseout=\"linkMsgStatus('out','');\"/g;
		       $collectchars =~ s/href=\"\/(.*?)\"/href=\"#\" onclick=\"linkGrab('\/$1');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/$1');\" onmouseout=\"linkMsgStatus('out','');\"/g;
		       $collectchars =~ s/HREF=\"\/(.*?)\"/href=\"#\" onclick=\"linkGrab('\/$1');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/$1');\" onmouseout=\"linkMsgStatus('out','');\"/g;
		       # Time-consuming process to translate hyperlinks that are just links in the same directory of the site that don't begin with a forward-slash and are not external links
		       my $collection, $scollection, $watch, $modpath;
		       $watch = 0; $collection = ""; $scollection = "";
		       $modpath = $target_full_address;
		       if ($modpath =~ /\./) { $modpath = ""; }
		       else { if (substr($modpath, length($modpath) - 1, 1) eq '/') { $modpath = substr($modpath, 0, length($modpath) - 1); } }
		       for (my $step = 0; $step < length($collectchars); $step++) {
							      			   my $cletter = substr($collectchars, $step, 1);
							      			   if ($watch == 1) { $scollection = $scollection . $cletter; }
							      			   if ($cletter eq '<') { $watch = 1; $scollection = $scollection . $cletter; }
							      			   if ($cletter eq '>' && $watch == 1) { $watch = 2; }
							      			   if ($watch == 0) { $collection = $collection . $cletter; }
							      			   if ($watch == 2) {
												     if ($scollection =~ /href=/i) {
																    if ($scollection !~ /http:/i && $scollection !~ /https:/i && $scollection !~ /linkgrab/i && $scollection !~ /linkmsgstatus/i) {
																																   $scollection =~ s/href='(.*?)'/href=\"#\" onclick=\"linkGrab('$modpath\/$1');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','$modpath\/$1');\" onmouseout=\"linkMsgStatus('out','');\"/g;
																																   $scollection =~ s/HREF='(.*?)'/href=\"#\" onclick=\"linkGrab('$modpath\/$1');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','$modpath\/$1');\" onmouseout=\"linkMsgStatus('out','');\"/g;
																																   $scollection =~ s/href=\"(.*?)\"/href=\"#\" onclick=\"linkGrab('$modpath\/$1');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','$modpath\/$1');\" onmouseout=\"linkMsgStatus('out','');\"/g;
																																   $scollection =~ s/HREF=\"(.*?)\"/href=\"#\" onclick=\"linkGrab('$modpath\/$1');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','$modpath\/$1');\" onmouseout=\"linkMsgStatus('out','');\"/g;
																																   $collection = $collection . $scollection;
																																   $scollection = ""; $watch = 0;
																					   				     							  }
																    elsif ($scollection =~ /http:\/\/$target_domain/i || $scollection =~ /https:\/\/$target_domain/i) {
																												       $scollection =~ s/href='(.*?)'/href=\"#\" onclick=\"linkGrab('\/');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/');\" onmouseout=\"linkMsgStatus('out','');\"/g;
																												       $scollection =~ s/HREF='(.*?)'/href=\"#\" onclick=\"linkGrab('\/');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/');\" onmouseout=\"linkMsgStatus('out','');\"/g;
																												       $scollection =~ s/href=\"(.*?)\"/href=\"#\" onclick=\"linkGrab('\/');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/');\" onmouseout=\"linkMsgStatus('out','');\"/g;
																												       $scollection =~ s/HREF=\"(.*?)\"/href=\"#\" onclick=\"linkGrab('\/');event.returnValue=false;return false;\" onmouseover=\"linkMsgStatus('over','\/');\" onmouseout=\"linkMsgStatus('out','');\"/g;
																												       $collection = $collection . $scollection;
																												       $scollection = ""; $watch = 0;
																	     											      }
																    else {
										      							  $collection = $collection . $scollection;
										      							  $scollection = ""; $watch = 0;
										     							 }
																   }
												     else {
													   $collection = $collection . $scollection;
													   $scollection = ""; $watch = 0;
													  }
												    }
							     			  }
		       $collectchars = $collection;
		      }
else {
      $collectchars =~ s/href=\//href=$absPath/g;
      $collectchars =~ s/HREF=\//HREF=$absPath/g;
      $collectchars =~ s/href='\//href=$absPathTick/g;
      $collectchars =~ s/HREF='\//HREF=$absPathTick/g;
      $collectchars =~ s/href=\"\//href=$absPathQuote/g;
      $collectchars =~ s/HREF=\"\//HREF=$absPathQuote/g;
     }

##### Show Response Of Running The Bot
print "Content-type: text/html\n\n";
print "<html>\n";
print "<head>\n";
print "<title>Web Bot Communication</title>\n";
print "<meta name=\"author\" content=\"Joe\" />\n";
print "<style type=\"text/css\">\n";
print "body {\n";
print "font-family: verdana;\n";
print "font-size: 10pt;\n";
print "}\n";
print "td {\n";
print "font-family: verdana;\n";
print "font-size: 10pt;\n";
print "}\n";
print "ol, ul {\n";
print "margin-top: 5px;\n";
print "}\n";
print "form {\n";
print "margin: 0 0 0 0;\n";
print "padding: 0 0 0 0;\n";
print "}\n";
print "h1, h2, h3 {\n";
print "font-size: 12pt;\n";
print "}\n";
print "h4, h5, h6 {\n";
print "font-size: 10pt;\n";
print "}\n";
print ".btnCloser {\n";
print "margin: 0 0 0 0;\n";
print "text-align: right;\n";
print "}\n";
print ".slideshow {\n";
print "zIndex: 100;\n";
print "overflow: auto;\n";
print "display: none;\n";
print "position: absolute;\n";
print "top: 20px;\n";
print "left: 20px;\n";
print "width: 1200px;\n";
print "height: 700px;\n";
print "border-left-width: 1px;\n";
print "border-right-width: 1px;\n";
print "border-top-width: 1px;\n";
print "border-bottom-width: 1px;\n";
print "border-style: solid;\n";
print "border-color: black;\n";
print "background-color: white;\n";
print "}\n";
print ".linkMsg {\n";
print "zIndex: 100;\n";
print "display: none;\n";
print "position: absolute;\n";
print "top: 722px;\n";
print "left: 20px;\n";
print "width: 1200px;\n";
print "height: 15px;\n";
print "font-family: verdana;\n";
print "font-size: 8pt;\n";
print "color: green;\n";
print "font-weight: bold;\n";
print "border-left-width: 1px;\n";
print "border-right-width: 1px;\n";
print "border-top-width: 1px;\n";
print "border-bottom-width: 1px;\n";
print "border-style: solid;\n";
print "border-color: black;\n";
print "background-color: white;\n";
print "}\n";
print "</style>\n";
print "<script language=\"javascript\" type=\"text/javascript\">\n";
print "cPos = new Array();\n";
print "var cPosIndex = -1;\n";
print "var txtLastValue = \"\";\n";
print "function txtLoader() {\n";
print "document.getElementById(\"theresults\").value = document.getElementById(\"grabber\").innerHTML;\n";
print "if (document.getElementById(\"ldState\").value.length > 0) {\n";
print "							    document.getElementById(\"ldState\").value = \"\";\n";
print "							    displayLoader();\n";
print "							   }\n";
print "}\n";
print "function displayLoader() {\n";
print "var content = document.getElementById(\"netgrabber\").innerHTML;\n";
print "content = \"<p class=\\\"btnCloser\\\"><input type=\\\"button\\\" name=\\\"clicker2\\\" onmousedown=\\\"slideclose();\\\" value=\\\"Close Display\\\" /></p><br />\" + content;\n";
print "document.getElementById(\"linkMsg\").style.display = \"inline\";\n";
print "document.getElementById(\"slideshow\").style.display = \"inline\";\n";
print "document.getElementById(\"slideshow\").innerHTML = content;\n";
print "}\n";
print "function slideclose() {\n";
print "document.getElementById(\"slideshow\").style.display = \"none\";\n";
print "document.getElementById(\"slideshow\").innerHTML = \"\";\n";
print "document.getElementById(\"linkMsg\").style.display = \"none\";\n";
print "document.getElementById(\"linkMsg\").innerHTML = \"\";\n";
print "}\n";
print "function txtFind(targetTxtField, matchTxt) {\n";
print "if (matchTxt.length > 0) {\n";
print "			  if (txtLastValue != matchTxt) { cPos = []; cPosIndex = -1; txtLastValue = matchTxt; }\n";
print "			  if (cPosIndex == -1) { txtIndexMatches(targetTxtField, matchTxt); }\n";
print "			  else { txtMatchHighlight(targetTxtField, matchTxt); }\n";
print "			 }\n";
print "}\n";
print "function txtIndexMatches(targetTxtField, matchTxt) {\n";
print "tmpArray = new Array(); tmpArray2 = new Array();\n";
print "try {\n";
print "     var inputString = matchTxt;\n";
print "     tmpArray = document.getElementById(targetTxtField).value.match(new RegExp(inputString, \"gi\"));\n";
print "     var handleData = document.getElementById(targetTxtField).value;\n";
print "     for (x = 0; x < tmpArray.length; x++) {\n";
print "					    tmpArray2[tmpArray2.length] = handleData.indexOf(inputString);\n";
print "					    handleData = handleData.substr(tmpArray2[tmpArray2.length - 1] + inputString.length, handleData.length);\n";
print "					    if (x == 0) { cPos[cPos.length] = tmpArray2[x]; }\n";
print "					    else { cPos[cPos.length] = cPos[cPos.length - 1] + tmpArray2[x] + inputString.length; }\n";
print "					   }\n";
print "     if (cPos.length > 0) {\n";
print "     			   /* Highlight first or only match */\n";
print "			   cPosIndex = 0;\n";
print "     			   txtMatchHighlight(targetTxtField, matchTxt);\n";
print "			  }\n";
print "    }\n";
print "catch (onerror) { /* No string match */ }\n";
print "}\n";
print "function txtMatchHighlight(targetTxtField, matchTxt) {\n";
print "var inputString = matchTxt;\n";
print "var oRange; var iStart = 0, iEnd = 0;\n";
print "if (cPosIndex > cPos.length - 1) { cPosIndex = 0; }\n";
print "iStart = cPos[cPosIndex]; iEnd = cPos[cPosIndex] + inputString.length; cPosIndex = cPosIndex + 1;\n";
print "if (navigator.userAgent.toLowerCase().indexOf(\"msie\") > -1) {\n";
print "						    	     oRange = document.getElementById(targetTxtField).createTextRange();\n";
print "						    	     oRange.moveStart(\"character\", iStart);\n";
print "						    	     oRange.moveEnd(\"character\", iEnd - parseInt(document.getElementById(targetTxtField).value.length));\n";
print "						   	    }\n";
print "else { oRange = document.getElementById(targetTxtField).setSelectionRange(iStart, iEnd); }\n";
print "oRange.select(); document.getElementById(targetTxtField).focus();\n";
print "}\n";
print "function linkMsgStatus(state, data) {\n";
print "if (state == \"over\") { document.getElementById(\"linkMsg\").innerHTML = \"That link will be sent to the bot for handling instead of your web browser.  Target location: \" + data + \"\"; }\n";
print "else { document.getElementById(\"linkMsg\").innerHTML = \"\"; }\n";
print "}\n";
print "function linkGrab(data) {\n";
print "oldAddress = document.getElementById(\"target_full_address\").value;\n";
print "document.getElementById(\"target_full_address\").value = data;\n";
print "document.getElementById(\"ldState\").value = \"spawn\";\n";
print "document.getElementById(\"botFrm\").target = \"_blank\";\n";
print "document.getElementById(\"botFrm\").submit();\n";
print "document.getElementById(\"botFrm\").target = \"_top\";\n";
print "document.getElementById(\"target_full_address\").value = oldAddress;\n";
print "document.getElementById(\"ldState\").value = \"\";\n";
print "}\n";
print "</script>\n";
print "</head>\n";
print "<body onload=\"txtLoader();\">\n";
print "<p style=\"text-align:center;\"><b>Web Bot Communication Results</b></p>\n";
print "<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\" width=\"97%\"><tr>\n";
print "<td width=\"50%\" valign=\"top\">\n";
print "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" width=\"100%\"><tr>\n";
print "<td width=\"30%\" valign=\"top\"><b>Status</b></td>\n";
print "<td width=\"70%\" valign=\"top\">$response</td>\n";
print "</tr><tr>\n";
print "<td width=\"30%\" valign=\"top\"><b>Port Used</b></td>\n";
print "<td width=\"70%\" valign=\"top\">$port</td>\n";
print "</tr><tr>\n";
print "<td width=\"30%\" valign=\"top\"><b>Agent Name</b></td>\n";
print "<td width=\"70%\" valign=\"top\">$agent_name</td>\n";
print "</tr><tr>\n";
print "<td width=\"30%\" valign=\"top\"><b>Agent Method</b></td>\n";
print "<td width=\"70%\" valign=\"top\">$agent_method</td>\n";
print "</tr><tr>\n";
print "</tr></table>\n";
print "</td>\n";
print "<td width=\"50%\" valign=\"top\">\n";
print "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" width=\"100%\"><tr>\n";
print "<td width=\"30%\" valign=\"top\"><b>Target Domain</b></td>\n";
print "<td width=\"70%\" valign=\"top\">$target_domain</td>\n";
print "</tr><tr>\n";
print "<td width=\"30%\" valign=\"top\"><b>Target File</b></td>\n";
print "<td width=\"70%\" valign=\"top\">$target_full_address</td>\n";
print "</tr><tr>\n";
print "<td width=\"30%\" valign=\"top\"><b>Request Type</b></td>\n";
print "<td width=\"70%\" valign=\"top\">$request_method</td>\n";
print "</tr><tr>\n";
print "<td width=\"30%\" valign=\"top\"><b>Request Protocol</b></td>\n";
print "<td width=\"70%\" valign=\"top\">$request_protocol</td>\n";
print "</tr><tr>\n";
print "</tr></table>\n";
print "</td>\n";
print "</tr></table>\n";
print "<b>Returned Data Stream:</b> <input type=\"button\" name=\"clicker\" onmousedown=\"displayLoader();\" value=\"Display Content\" /><br />\n";
print "<textarea name=\"theresults\" id=\"theresults\" cols=\"115\" rows=\"12\" wrap=\"on\"></textarea>\n";
print "<div id=\"netgrabber\" style=\"display: none;\">\n";
print "$collectchars\n";
print "</div>\n";
print "<div id=\"grabber\" style=\"display: none;\">\n";
$captured_response =~ s/</&lt;/g; $captured_response =~ s/>/&gt;/g;
print "$captured_response";
print "</div>\n";
print "<br /><br />\n";
print "<form id=\"botFrm\" method=\"post\" action=\"/cgi-bin/web_bot.cgi\" target=\"_top\">\n";
print "<input type=\"hidden\" name=\"ldState\" id=\"ldState\" value=\"$FORM{'ldState'}\" />\n";
print "<b>Web Page:</b><br />\n";
if (length($FORM{'target_domain'}) > 0) { print "Enter Domain: <input type=\"text\" name=\"target_domain\" size=\"20\" value=\"$FORM{'target_domain'}\">\n"; }
else { print "Enter Domain: <input type=\"text\" name=\"target_domain\" size=\"20\" value=\"www.somesite.com\">\n"; }
if (length($FORM{'target_full_address'}) > 0) { print "Enter Full URL: <input type=\"text\" name=\"target_full_address\" size=\"50\" value=\"$FORM{'target_full_address'}\">\n"; }
else { print "Enter Full URL: <input type=\"text\" name=\"target_full_address\" size=\"50\" value=\"www.somesite.com/index.html\">\n"; }
print " <input type=\"submit\" value=\"Grab Page\" />\n";
print "<hr />\n";
print "If domain [www.somesite.com], Full URL [www.somesite.com/index.html] does not work try:<br />\n";
print "domain [www.somesite.com], Full URL [/index.html] or something like [/forum1/08/01/09/pg1].\n";
print "<hr />\n";
print "<b>Other Configurations:</b><br /><br />\n";
if (length($FORM{'port'}) > 0) { print "Enter Port: <input type=\"text\" name=\"port\" size=\"3\" value=\"$FORM{'port'}\" />\n"; }
else { print "Enter Port: <input type=\"text\" name=\"port\" size=\"3\" value=\"80\" />\n"; }
if (length($FORM{'agent_name'}) > 0) { print " Bot (Agent) Name: <input type=\"text\" name=\"agent_name\" size=\"14\" value=\"$FORM{'agent_name'}\" />\n"; }
else { print " Bot (Agent) Name: <input type=\"text\" name=\"agent_name\" size=\"14\" value=\"wwwindexer\" />\n"; }
if (length($FORM{'agent_method'}) > 0) { print " HTTP Method: <input type=\"text\" name=\"agent_method\" size=\"14\" value=\"$FORM{'agent_method'}\" />\n"; }
else { print " HTTP Method: <input type=\"text\" name=\"agent_method\" size=\"14\" value=\"http-get/0.1\" />\n"; }
if (length($FORM{'request_method'}) > 0) { print " Request Method: <input type=\"text\" name=\"request_method\" size=\"9\" value=\"$FORM{'request_method'}\" />\n"; }
else { print " Request Method: <input type=\"text\" name=\"request_method\" size=\"9\" value=\"GET\" />\n"; }
if (length($FORM{'request_protocol'}) > 0) { print " Request Protocol: <input type=\"text\" name=\"request_protocol\" size=\"9\" value=\"$FORM{'request_protocol'}\" />\n"; }
else { print " Request Protocol: <input type=\"text\" name=\"request_protocol\" size=\"9\" value=\"HTTP/1.0\" />\n"; }
print "<br />\n";
print "Allow SRC Path Translation (this means SRC elements, like images and javascript, will be active): <select name=\"allowimages\">\n";
if ($allowimages == 1) { print "<option value=\"1\"> Yes </option><option value=\"0\"> No </option>\n"; }
else { print "<option value=\"0\"> No </option><option value=\"1\"> Yes </option>\n"; }
print "</select>\n";
print "<br />\n";
print " Allow HREF Path Translation (links pass to bot for processing): <select name=\"allowlinks\">\n";
if ($allowlinks == 1) { print "<option value=\"1\"> Yes </option><option value=\"0\"> No </option>\n"; }
else { print "<option value=\"0\"> No </option><option value=\"1\"> Yes </option>\n"; }
print "</select>\n";
print "<hr />\n";
print "<b>Jump To Area In Returned Data Stream:</b> (useful for locating something of interest manually in the source code)<br />\n";
print "Enter Text To Jump To: <input type=\"text\" id=\"jumpTxt\" size=\"20\" value=\"\" /> <input type=\"button\" id=\"jumper\" value=\"Jump\" onmouseup=\"txtFind('theresults', document.getElementById('jumpTxt').value);\" />\n";
print "</form>\n";
print "<div id=\"slideshow\" class=\"slideshow\"></div><div id=\"linkMsg\" class=\"linkMsg\"></div>\n";
print "</body>\n";
print "</html>\n";
exit;